package org.hso.ecommerce.app.config;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

import org.hso.ecommerce.app.config.YAMLData.Address;
import org.springframework.stereotype.Component;
import org.yaml.snakeyaml.Yaml;
import org.yaml.snakeyaml.constructor.Constructor;

@Component
public class AppSettings {
	private static AppSettings instance;

	private AppSettings() {
		// constructor
	}

	public static AppSettings getInstance() {
		if (instance == null) {
			instance = new AppSettings();
		}
		return instance;
	}

	public void writeDemoConfig() {
		YAMLData data = new YAMLData();
		data.setInstallationName("Fast-Web-Shop");
		data.setCompanyName("newCommerce GmbH");
		data.setCompanyAddress(new Address(
				"Kupfergraben",
				"6",
				"10117",
				"Berlin",
				"Germany"
		));
		data.setNumberOfStorageSpaces(128);
		
//		List<YAMLData.Supplier> suppliers = new ArrayList<YAMLData.Supplier>();
//		suppliers.add(new YAMLData.Supplier("Reichelt elektronik GmbH & Co. KG", "d41d8cd98f00b204e9800998ecf8427e",
//				"https://reichelt.api.ecommerce.mosad.xyz",
//				new Address("Elektronikring", "1", "26452", "Sande", "Germany"), 4));
//		suppliers.add(new YAMLData.Supplier("Conrad Electronic SE", "18a17da5bac1cf00551b08c3e98720f5",
//				"https://conrad.api.ecommerce.mosad.xyz",
//				new Address("Klaus-Conrad-Straße", "1", "92240", "Hirschau", "Germany"), 5));
//
//		data.setSuppliers(suppliers);

		data.setParcelServiceName("DHL International GmbH");
		data.setParcelServiceApiURL("https://dhl.api.ecommerce.mosad.xyz");

		try (FileWriter writer = new FileWriter("./eCommerce_config.yml")) {
			Yaml yaml = new Yaml();
			yaml.dump(data, writer);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public YAMLData readConfig() {
		YAMLData data = new YAMLData();

		try (InputStream inputStream = new FileInputStream("./eCommerce_config.yml")) {
			Yaml yaml = new Yaml(new Constructor(YAMLData.class));
			data = yaml.load(inputStream);

			System.out.println(data.getCompanyName());
		} catch (IOException e) {
			e.printStackTrace();
		}

		return data;
	}

}